config/routes.rb
# file: rails-generate-pdf/app/config/routes.rb
Rails.application.routes.draw do
  root to: 'invoices#index'

  resources :invoices, only: [:index, :show]
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/invoice.rb
# file: rails-generate-pdf/app/models/invoice.rb
class Invoice < ApplicationRecord
  has_many :invoice_items, dependent: :destroy

  STATUS_CLASS = {
      :draft => "badge badge-secondary",
      :sent => "badge badge-primary",
      :paid => "badge badge-success"
  }

  def subtotal
      self.invoice_items.map { |item| item.qty * item.price }.sum
  end

  def discount_calculated
      subtotal * (self.discount / 100.0)
  end

  def vat_calculated
      (subtotal - discount_calculated) * (self.vat / 100.0)
  end

  def total
      subtotal - discount_calculated + vat_calculated
  end

  def status_class
      STATUS_CLASS[self.status.to_sym]
  end

end

app/models/invoice_item.rb
# file: rails-generate-pdf/app/models/invoice_item.rb
class InvoiceItem < ApplicationRecord
  belongs_to :invoice
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/invoices_controller.rb
# file: rails-generate-pdf/app/controllers/invoices_controller.rb
class InvoicesController < ApplicationController
  def index
      @invoices = scope
  end

  def show
      @invoice = scope.find(params[:id])

      respond_to do |format|
          format.html
          format.pdf do
              render pdf: "Invoice No. #{@invoice.id}",
              page_size: 'A4',
              template: "invoices/show.html.erb",
              layout: "pdf.html",
              orientation: "Landscape",
              lowquality: true,
              zoom: 1,
              dpi: 75
          end
      end
  end

  private
      def scope
          ::Invoice.all.includes(:invoice_items)
      end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/invoices_helper.rb
module InvoicesHelper
end

app/views/invoices/index.html.erb
<h1>Invoices#index</h1>
<p>Find me in app/views/invoices/index.html.erb</p>

app/views/invoices/show.html.erb
<div class="invoice-box">
        <table cellpadding="0" cellspacing="0">
          <tr class="top">
            <td colspan="4">
              <table>
                <tr>
                  <td class="title">
                    logo
                  </td>

                  <td>
                    Invoice #: <b><%= @invoice.id %></b>
                    <br>
                    Created: <b><%= @invoice.created_at.strftime('%d/%m/%Y') %></b>
                    <br>
                    Due: <b><%= (@invoice.created_at + 1.month).strftime('%d/%m/%Y') %></b>
                    <br>
                    Status: <span class="<%= @invoice.status_class %>"><%= @invoice.status %></span>
                  </td>
                </tr>
              </table>
            </td>
          </tr>

          <tr class="information">
            <td colspan="4">
              <table>
                <tr>
                  <td>
                    <b><%= @invoice.from_full_name %></b><br>
                    <%= @invoice.from_address %><br>
                    <i class="far fa-envelope"></i> <%= @invoice.from_email %><br>
                    <i class="fas fa-phone"></i> <%= @invoice.from_phone %>
                  </td>

                  <td>
                    <b><%= @invoice.to_full_name %></b><br>
                    <%= @invoice.to_address %><br>
                    <i class="far fa-envelope"></i> <%= @invoice.to_email %><br>
                    <i class="fas fa-phone"></i> <%= @invoice.to_phone %>
                  </td>
                </tr>
              </table>
            </td>
          </tr>

          <tr class="heading">
            <td>Payment Method</td>
            <td colspan="2"></td>
            <td class="right">Cache</td>
          </tr>

          <tr class="details">
            <td>Delivery Method</td>
            <td colspan="2"></td>
            <td class="right">1000</td>
          </tr>

          <tr class="heading">
            <td>Item</td>
            <td class="right">Price</td>
            <td class="right">Qty</td>
            <td>Total</td>
          </tr>

          <% @invoice.invoice_items.each do |invoice_item| %>
            <tr class="item">
                <td>
                    <%= invoice_item.name %><br>
                    <small><%= invoice_item.description %></small>
                </td>

                <td class="right">
                    <%= number_to_currency(invoice_item.price) %>
                </td>

                <td class="right">
                    x <%= invoice_item.qty %>
                </td>

                <td>
                    <%= number_to_currency(invoice_item.price * invoice_item.qty) %>
                </td>
            </tr>
          <% end %>

          <tr>
            <td colspan="4"></td>
          </tr>

          <tr>
            <td colspan="2"></td>
            <td><b>Subtotal</b></td>
            <td><%= number_to_currency(@invoice.subtotal) %></td>
          </tr>

          <tr>
            <td colspan="2"></td>
            <td><b>Discount (<%= @invoice.discount %>%)</b></td>
            <td>- <%= number_to_currency(@invoice.discount_calculated) %></td>
          </tr>

          <tr>
            <td colspan="2"></td>
            <td><b>VAT (<%= @invoice.vat %>%)</b></td>
            <td>+ <%= number_to_currency(@invoice.vat_calculated) %></td>
          </tr>

          <tr class="heading">
            <td colspan="2"></td>
            <td><b>TOTAL:</b></td>
            <td>
               <b><%= number_to_currency(@invoice.total) %></b>
            </td>
          </tr>
        </table>
    </div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>RailsGeneratePdf</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/layouts/pdf.html.erb
<!DOCTYPE html>
<html>
<head>
<title>PDFs - Ruby on Rails</title>
    <%= wicked_pdf_stylesheet_link_tag "invoice" %>
</head>
<body>
    <%= yield %>
</body>
</html>

app/views/layouts/shared/_header.html.erb
<%= link_to ‘DOWNLOAD PDF’, invoice_path(@invoice, format: :pdf) %>